var Ctx = {
    anon: {}
};

Ctx.sync = function(cb) {
    var jobs = 0;
    this.await = function() {jobs++;};
    this.signal = function() {if (--jobs == 0) cb();}
};

Ctx.res = function(dataProvider, sync) {
    this.sync = sync;
    this.dataProvider = dataProvider;
    this.buffer = [];
    this.getBlock = Ctx.getBlock;
    this.init = Ctx.init;
    this._render = Ctx._render;

    this.write = function(str) {
        this.buffer.push(str);
    };
    this.fork = function() {
        var r = new Ctx.res(this.dataProvider, this.sync);
        this.buffer.push(r);
        return r;
    };

    this._body = function() {
        var idx = 0;
        var body = "";
        while (idx < this.buffer.length) {
            var b = this.buffer[idx++];
            if (typeof b !== "undefined" && b._body) {
                body += b._body();
            } else {
                body += b;
            }
        }
        return body;
    };
};
Ctx.getBlock = function(name) {
    var ref = Ctx.schema[name];
    if (!ref) throw new Error("Could not find block: " + name);
    if (!ref.class) {
        ref = Ctx.init(null, ref);
    }
    return ref;
};
Ctx.init = function(seq, block) {
    var a;
    if (seq) {
        a = Ctx.anon[seq];
    }
    if (!a) {
        a = function() {};
        if (block.parent) {
            a.prototype = Object.create(Ctx.getBlock(block.parent).class.prototype);
        }
    }
    a.handler = block.handler;
    for (var f in block)
        if (typeof block[f] === "function") {
            a.prototype[f] = block[f];
        }

    var a1 = new a();
    a1.class = a;
    if (seq) Ctx.anon[seq] = a;
    return a1;
};
Ctx._render = function(bl, attrs, res) {
    this.sync.await();
    if(bl.class.handler && res.dataProvider) {
        var h = res.dataProvider.get(bl.class.handler);
        if (!h) {
            throw new Error("Could not find data provider " + bl.handler);
        }
        res = res.fork();
        var selfSync = this.sync;
        h(attrs, function(err, data) {
            if (err) throw err;
            bl.body(data, res);
            selfSync.signal();
        });
    } else {
        bl.body(attrs, res);
        this.sync.signal();
    }
};
Ctx.render = function(name, data, provider, cb) {
    name = name.replace(/\\/g, "/");
    var res = new Ctx.res(provider, new Ctx.sync(function() {
        cb(null, res._body());
    }));
    try {
        res._render(res.getBlock(name), data, res);
    } catch(e) {
        cb(e, null);
    }
};

if (typeof module !== 'undefined') {module.exports = Ctx;}
Ctx.schema = { "anon:A":{ body:function (attrs, res) {res.write((attrs.x));
} },
  "anon:B":{ body:function (attrs, res) {res._render(res.getBlock('anon:A'),{x:(attrs.x),}, res);
} },
  "anon/cascade-named:A":{ def_1:function (attrs, res) {},
    body:function (attrs, res) {res.write('a');
this.def_1(attrs, res);
res.write('a');
} },
  "anon/cascade-named:B":{ body:function (attrs, res) {res.write('b');
var self = this;
res._render(res.init(0, {parent: 'anon/cascade-named:A',def: function(_a, res) {self.def_1(attrs, res);
},def_1: function(_a, res) {self.def_1(null, res)},}),{}, res);
res.write('b');
} },
  "anon/cascade-named:C":{ body:function (attrs, res) {res.write('c');
var self = this;
res._render(res.init(1, {parent: 'anon/cascade-named:B',def: function(_a, res) {self.def_1(attrs, res);
},def_1: function(_a, res) {self.def_1(null, res)},}),{}, res);
res.write('c');
} },
  "anon/cascade-named:D":{ body:function (attrs, res) {res.write('d');
this.class.prototype.def_1=function(_a, res) {res.write('hello');
};
var self = this;
res._render(res.init(2, {parent: 'anon/cascade-named:C',def: function(_a, res) {self.def_1(attrs, res);
},def_1: function(_a, res) {self.def_1(null, res)},}),{}, res);
res.write('d');
} },
  "anon/cascade:A":{ def:function (attrs, res) {},
    body:function (attrs, res) {res.write('a');
this.def(attrs, res);
res.write('a');
} },
  "anon/cascade:B":{ body:function (attrs, res) {res.write('b');
var self = this;
res._render(res.init(0, {parent: 'anon/cascade:A',def: function(_a, res) {self.def(attrs, res);
},def: function(_a, res) {self.def(null, res)},}),{}, res);
res.write('b');
} },
  "anon/cascade:C":{ body:function (attrs, res) {res.write('c');
var self = this;
res._render(res.init(1, {parent: 'anon/cascade:B',def: function(_a, res) {self.def(attrs, res);
},def: function(_a, res) {self.def(null, res)},}),{}, res);
res.write('c');
} },
  "anon/cascade:D":{ body:function (attrs, res) {res.write('d');
var self = this;
res._render(res.init(2, {parent: 'anon/cascade:C',def: function(_a, res) {res.write('hello');
},}),{}, res);
res.write('d');
} },
  "anon/new-def:A":{ def_a:function (attrs, res) {},
    body:function (attrs, res) {res.write('a');
this.def_a(attrs, res);
res.write('a');
} },
  "anon/new-def:B":{ def_b:function (attrs, res) {},
    body:function (attrs, res) {res.write('b');
this.def_b(attrs, res);
res.write('b');
} },
  "anon/new-def:C":{ parent:"anon/new-def:A",
    def_a:function (attrs, res) {this.class.prototype.def_b=function(_a, res) {self.def_c(attrs, res);
};
var self = this;
res._render(res.init(0, {parent: 'anon/new-def:B',def: function(_a, res) {self.def_b(attrs, res);
},def_b: function(_a, res) {self.def_b(null, res)},}),{}, res);
} },
  "anon/new-def:D":{ parent:"anon/new-def:C",
    def_c:function (attrs, res) {res.write('d');
} },
  "handler/cascade:A":{ handler:"a",
    body:function (attrs, res) {res.write((attrs.x));
} },
  "handler/cascade:B":{ handler:"b",
    body:function (attrs, res) {res.write((attrs.z));
res._render(res.getBlock('handler/cascade:A'),{y1:'f',}, res);
} },
  "handler/simple:A":{ handler:"a",
    body:function (attrs, res) {res.write((attrs.x));
} },
  "inheritance/cascade:A":{ def_a:function (attrs, res) {},
    body:function (attrs, res) {res.write('a1');
this.def_a(attrs, res);
res.write('a2');
} },
  "inheritance/cascade:B":{ parent:"inheritance/cascade:A",
    def_a:function (attrs, res) {res.write('b1');
this.def_b(attrs, res);
res.write('b2');
} },
  "inheritance/cascade:C":{ parent:"inheritance/cascade:B",
    def_b:function (attrs, res) {res.write('b in C');
} },
  "inheritance/default-defs:A":{ def_a:function (attrs, res) {res.write('a definition');
},
    body:function (attrs, res) {this.def_a(attrs, res);
} },
  "inheritance/default-defs:B":{ parent:"inheritance/default-defs:A" },
  "inheritance/default-defs:C":{ parent:"inheritance/default-defs:B" },
  "inheritance/multi:A":{ def:function (attrs, res) {},
    body:function (attrs, res) {this.def(attrs, res);
} },
  "inheritance/multi:B":{ parent:"inheritance/multi:A",
    def:function (attrs, res) {res.write('hello from B');
} },
  "inheritance/multi:C":{ parent:"inheritance/multi:B",
    def:function (attrs, res) {res.write('hello from C');
} },
  "inheritance/named-defs:A":{ def_a:function (attrs, res) {},
    def_b:function (attrs, res) {},
    body:function (attrs, res) {this.def_a(attrs, res);
this.def_b(attrs, res);
} },
  "inheritance/named-defs:B":{ parent:"inheritance/named-defs:A",
    def_a:function (attrs, res) {res.write('a in B');
},
    def_b:function (attrs, res) {res.write('b in B');
} },
  "inheritance/named-defs:C":{ parent:"inheritance/named-defs:B",
    def_a:function (attrs, res) {res.write('a in C');
},
    def_b:function (attrs, res) {res.write('b in C');
} },
  "inheritance/simple:A":{ def:function (attrs, res) {},
    body:function (attrs, res) {this.def(attrs, res);
} },
  "inheritance/simple:B":{ parent:"inheritance/simple:A",
    def:function (attrs, res) {res.write('hello');
} },
  "var/for:A":{ def:function (attrs, res) {},
    body:function (attrs, res) {this.def(attrs, res);
} },
  "var/for:B":{ body:function (attrs, res) {var self = this;
res._render(res.init(0, {parent: 'var/for:A',def: function(_a, res) {res.write((attrs.x));
},}),{}, res);
} },
  "var/for:C":{ body:function (attrs, res) {res._render(res.getBlock('var/for:B'),{x:'1',}, res);
res._render(res.getBlock('var/for:B'),{x:'2',}, res);
res._render(res.getBlock('var/for:B'),{x:'3',}, res);
} },
  "var:var":{ body:function (attrs, res) {res.write((attrs.x));
} },
  "var:parent_test":{ parent:"var:var" },
  "var:_anon_def_test":{ def:function (attrs, res) {},
    body:function (attrs, res) {this.def(attrs, res);
} },
  "var:anon_def_test":{ parent:"var:_anon_def_test",
    def:function (attrs, res) {res.write((attrs.x));
} },
  "var:_call_parent":{ def:function (attrs, res) {res.write('parent');
},
    body:function (attrs, res) {this.def(attrs, res);
} },
  "var:call_parent":{ parent:"var:_call_parent",
    def:function (attrs, res) {res.getBlock('var:_call_parent')['def'](attrs, res);
} },
  "var:__context_":{ def:function (attrs, res) {},
    body:function (attrs, res) {res.write('0-open '+(attrs.x));
this.def(attrs, res);
res.write('0-close '+(attrs.x));
} },
  "var:_context":{ def:function (attrs, res) {},
    body:function (attrs, res) {res.write('1-open '+(attrs.x));
this.def(attrs, res);
res.write('1-close '+(attrs.x));
} },
  "var:_context_":{ parent:"var:__context_",
    def:function (attrs, res) {var self = this;
res._render(res.init(0, {parent: 'var:_context',def: function(_a, res) {res.write('2-open '+(attrs.x));
self.def_1(attrs, res);
res.write('2-close '+(attrs.x));
},def_1: function(_a, res) {self.def_1(null, res)},}),{}, res);
} },
  "var:context":{ parent:"var:_context_",
    def_1:function (attrs, res) {res.write('in '+(attrs.x));
} } }